#!/usr/bin/python

import names
from numpy.random import choice

operations = ["insert", "pop", "top"]

def generate_stress_tests(file_name, nr_operations, priorities, probabilities):
    f_in = open(file_name, "wt")
    ops = []

    seen_names = set()
    seen_priorities = set()

    for i in range(nr_operations):

        op = choice(operations, p = probabilities)

        if op == "insert":
            name = names.get_first_name()
            priority = choice(priorities)

            while name in seen_names:
                name = names.get_first_name()

            while priority in seen_priorities:
                priority = choice(priorities)

            seen_priorities.add(priority)
            seen_names.add(name)

            ops.append(["insert", name, str(priority)])

        elif op in ["top", "pop"]:
            ops.append([op])

    for op in ops:
        print(op)
        f_in.write(" ".join(op) + "\n")

    f_in.close()


if __name__ == "__main__":
    generate_stress_tests("test16.in", 1000, range(10000), [0.7, 0.2, 0.1])
    #generate_stress_tests("test9.in", 1000, range(1000000), [0.6, 0.2, 0.2])
    #generate_stress_tests("test10.in", 1000, range(1000000), [0.5, 0.3, 0.2])
